=== debian/changelog ===
hdf5 (1.8.8-7.1) unstable; urgency=low

  * Non-maintainer upload.
  * Stop building the c++ libraries, nothing uses them.  And don't version the
    libhdf5-7 symbols file, so the dependency can also be satisfied by the mpi
    packages' Provides.
  * Use DEB_HOST_ARCH instead of DEB_BUILD_ARCH in debian/rules.
  * Don't require root for debian/rules clean.

 -- Julien Cristau <jcristau@debian.org>  Sat, 18 Feb 2012 12:25:35 +0000

hdf5 (1.8.8-7) unstable; urgency=low

  * Now shlibs suggest both parallel or serial version to avoid problems
    with rdepends that could use both serial or parallel version to build and
    are 'parallel agnostic'.
    (closes: #657949, #658281, #658307)
  * Now hdf5-tools depends strictly on the provided library in the source.
    Using a virtual is quite pointless, being hdf5-tools provided by the
    same source package.
    (closes: #658491)

 -- Francesco Paolo Lovergine <frankie@debian.org>  Mon, 13 Feb 2012 10:53:23 +0100

hdf5 (1.8.8-6) unstable; urgency=low

  * Support of alpha & sh4. Thanks to Michael Cree & Nobuhiro Iwamatsu.
    (Closes: #656516)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 31 Jan 2012 15:23:17 +0100

hdf5 (1.8.8-5) unstable; urgency=low

  * Force the path to OpenMPI. This might fix the FTBFS on sparc.
  * Force to quit when the configure is failing. Thanks to 
    Julien Cristau for the suggestion.

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 23 Jan 2012 18:16:53 +0100

hdf5 (1.8.8-4) unstable; urgency=low

  * Update the symbol list under ia64
  * In case of failure of the configure, display the config.log file.
    Enabled because of the build failure under sparc.

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 23 Jan 2012 12:06:38 +0100

hdf5 (1.8.8-3) unstable; urgency=low

  * libhdf5-openmpi-7-dbg was build for arch:any while it should be built
    only on openmpi supported archs
  * Some weird artefacts in the define were breaking ia64 build
  * Force g++ as the C++ compiler
  * Update the symbol list for sparc
  * In some cases, configures were executed in parallel. Disable it.
  * hdf5-helpers collided with hdf5-tools at upgrade time (Closes: #656427)
  * hdf5-tools could not be installed at the same time as libhdf5-openmpi-7
    or libhdf5-mpich2-7

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 19 Jan 2012 14:28:13 +0100

hdf5 (1.8.8-2) unstable; urgency=low

  * Fix an upstream wrong assumption that ia64 => ifort as
    Fortran compiler.
    Should fix ia64 (and maybe sparc) FTBFS.
  * Add a transitionnal package libhdf5-serial-dev => libhdf5-dev
  * libhdf5-mpich2-dev was depending on libmpich21.0-dev (should instead depend
    on libmpich2-dev)
  * Fix symbol list for alpha (Closes: #656299)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 17 Jan 2012 20:21:02 +0100

hdf5 (1.8.8-1) unstable; urgency=low

  * Upload in unstable
  * Fix the build under armhf

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 17 Jan 2012 18:20:32 +0100

hdf5 (1.8.8-1~exp4) experimental; urgency=low

  * Fix a symbol issue under armel and armhf

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 14 Jan 2012 14:33:21 +0100

hdf5 (1.8.8-1~exp3) experimental; urgency=low

  * Add mpi support for armel/armhf. Thanks to Konstantinos Margaritis
    for the patch (Closes: #654857)

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 09 Jan 2012 04:31:58 +0100

hdf5 (1.8.8-1~exp2) experimental; urgency=low

  * Update the symbol list under s390x. Thanks to Aurelien Jarno.
    (Closes: #651805)

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 12 Dec 2011 19:59:54 +0100

hdf5 (1.8.8-1~exp1) experimental; urgency=low

  * New upstream release (Closes: #649114)
  * fix lintian warning brace-expansion-in-debhelper-config-file
  * sscanf.diff & disabler16check.diff removed (applied upstream)
  * Add a script to sync the doc with the latest release. Thanks to
    Antonio Valentino for providing pack-hdf5docs.sh. (Closes: #610866)
  * package-would-benefit-from-build-arch-targets fixed
  * Use a distinct tarballs for the documentation

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 16 Nov 2011 11:42:52 +0100

hdf5 (1.8.7-2~exp7) experimental; urgency=low

  * Fix a mistake in the powerpc symbol file
  * mipsel and hurd-i386 symbols
  * s390x support. Thanks to Aurelien Jarno (Closes: #638363)
  * New package hdf5-helpers introduced. Contains now h5cc, h5c++ & h5fc.
    All hdf5 *-dev now depends on it (Closes: #629157, #637749)
    (LP: #770347)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 12 Aug 2011 15:19:01 +0200

hdf5 (1.8.7-2~exp6) experimental; urgency=low

  * Close to the end: mips & powerpc symbols
  * Debug packages libhdf5-7-dbg, libhdf5-mpich2-7-dbg &
    libhdf5-openmpi-7-dbg added (Closes: #604913)
  * debian/rules: Some lam old commands removed
  * debian/html.tgz.uu: Repack with a correctly formated pdf (Closes: #585491)
  * Do not compress the pdfs of the documentation

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 10 Aug 2011 20:21:46 +0200

hdf5 (1.8.7-2~exp5) experimental; urgency=low

  * Armel, s390 & powerpc symbol updates

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 10 Aug 2011 12:15:24 +0200

hdf5 (1.8.7-2~exp4) experimental; urgency=low

  * Fix a mistake in the symbol declaration

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 09 Aug 2011 11:10:09 +0200

hdf5 (1.8.7-2~exp3) experimental; urgency=low

  * kfreebsd-amd64, kfreebsd-i386, s390, mipsel, armel & powerpc symbols

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 08 Aug 2011 20:25:49 +0200

hdf5 (1.8.7-2~exp2) experimental; urgency=low

  * Update of the symbol files. Further uploads might come. (Closes: #636967)
  * Fix package-relation-with-self on libhdf5-7 (Provides:)
  * Fix a typo in the manpage h5import & h5diff
  * Missing manpages for h5copy h5fc h5mkgrp h5perf_serial h5stat
  * Enable parallel compilation

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 08 Aug 2011 13:22:06 +0200


